ercess/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('home.urls')),
    path('admin/', admin.site.urls),
]

home/urls.py
from django.urls import path
from .views import LandingPage, Dashboard, LoginPage
from django.contrib.auth import views as auth_views

app_name = "home"

urlpatterns = [
    path('', LandingPage.as_view(), name="index"),
    path('login/', LoginPage.as_view(), name="login"),
    path('logout/', auth_views.LogoutView.as_view(
        template_name="index.html"), name="logout"),
    path('dashboard/', Dashboard.as_view(), name="dashboard"),
]

home/forms.py
from django import forms
from django.contrib.auth.models import User
import re
from crispy_forms.helper import FormHelper


class LoginForm(forms.ModelForm):
    username = forms.CharField(required=True)
    password = forms.CharField(required=True, widget=forms.PasswordInput())

    class Meta:
        model = User
        fields = ("username", "password")

    def __init__(self, *args, **kwargs):
        super(LoginForm, self).__init__(*args, **kwargs)
        self.fields['username'].label = "Name"

    def authenticate(self, request, username=None, password=None, **kwargs):
        try:
            user = User._default_manager.get_by_natural_key(username)
            if user.check_password(password):
                return user
            else:
                return "err_pwd"
                # User().set_password(password)
                # return user
        except User.DoesNotExist:
            # Run the default password hasher once to reduce the timing
            # difference between an existing and a non-existing user (#20760).
            return None


class SignupForm(forms.ModelForm):
    # name = forms.CharField(required=True,)
    email = forms.EmailField(required=True,)
    password = forms.CharField(widget=forms.PasswordInput())
    confirm_password = forms.CharField(widget=forms.PasswordInput())

    class Meta:
        model = User
        fields = ("username", "email", "password", "confirm_password")

    def __init__(self, *args, **kwargs):
        super(SignupForm, self).__init__(*args, **kwargs)
        self.fields['username'].label = "Name"
        self.fields['username'].help_text = None
        self.helper = FormHelper(self)
        
    def clearFormError(self):
        self.helper.form_show_errors = False

    def clean(self):
        cleaned_data = super(SignupForm, self).clean()
        name = cleaned_data.get("name")
        email = cleaned_data.get("email")
        password = cleaned_data.get("password")
        confirm_password = cleaned_data.get("confirm_password")

        # existing_name = User.objects.filter(email__iexact=name)

        # existing_email = User.objects.filter(username__iexact=email)
        existing_name = User.objects.filter(username=name)

        existing_email = User.objects.filter(email=email)

        if existing_name.exists():
            raise forms.ValidationError(
                ("A user with this name already exists."))

        if existing_email.exists():
            raise forms.ValidationError(
                ("A user with this e-mail already exists."))

        regex = re.compile('[@_!#$%^&*()<>?/\|}{~:]')

        if len(password) < 8:
            raise forms.ValidationError(
                "Password should contain atleast 8 characters"
            )
        elif password != confirm_password:
            raise forms.ValidationError(
                "Password and Confirm password does not match"
            )
        elif(regex.search(password) is None):
            raise forms.ValidationError(
                "Password should contain atleast one special character"
            )

    def validateValues(self):
        cleaned_data = super(SignupForm, self).clean()
        name = cleaned_data.get("name")
        email = cleaned_data.get("email")
        password = cleaned_data.get("password")
        confirm_password = cleaned_data.get("confirm_password")

        existing_name = User.objects.filter(username=name)

        existing_email = User.objects.filter(email=email)

        if existing_name.exists():
            return "A user with this name already exists."
            # return forms.ValidationError(
            #     ("A user with this name already exists."))

        if existing_email.exists():
            return "A user with this e-mail already exists."
            # return forms.ValidationError(
            #     ("A user with this e-mail already exists."))

        regex = re.compile('[@_!#$%^&*()<>?/\|}{~:]')

        if len(password) < 8:
            return"Password should contain atleast 8 characters"
        elif password != confirm_password:
            return "Password and Confirm password does not match"
        elif(regex.search(password) is None):
            return "Password should contain atleast one special character"

home/views.py
from django.shortcuts import render, HttpResponseRedirect, redirect
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin
from .forms import LoginForm, SignupForm
from django.contrib.auth.models import User
from django.http import JsonResponse
from django.contrib.auth import login as auth_login
from django.contrib import messages
from django.core.mail import send_mail
from django.conf import settings
import threading


class LandingPage(generic.TemplateView):
    template_name = "index.html"


class Dashboard(LoginRequiredMixin, generic.TemplateView):
    template_name = "dashboard.html"

    def get_context_data(self, **kwargs):
        context = super(Dashboard, self).get_context_data(**kwargs)
        return context


class EmailThread(threading.Thread):
    def __init__(self, subject, html_content, recipient_list):
        self.subject = subject
        self.recipient_list = recipient_list
        self.html_content = html_content
        threading.Thread.__init__(self)

    def run(self):
        email_from = settings.EMAIL_HOST_USER
        send_mail(self.subject, self.html_content,
                  email_from, self.recipient_list)


class LoginPage(generic.TemplateView):
    model = User
    template_name = "login.html"

    def get_context_data(self, **kwargs):
        context = super(LoginPage, self).get_context_data(**kwargs)
        context['login_form'] = LoginForm
        context['signup_form'] = SignupForm
        return context

    def post(self, request, **kwargs):
        if request.POST.get('submit') == 'sign_in':
            form = LoginForm(request.POST)
            user = form.authenticate(username=request.POST.get(
                'username'), password=request.POST.get('password'),
                request=request)

            if user is not None and user != "err_pwd":
                # print("make user logged in ")
                auth_login(request, user)
                return HttpResponseRedirect('/dashboard')
            elif user == "err_pwd":
                messages.error(request, "Invalid credentials")
                return render(request, 'login.html', {'login_form':
                                                      LoginForm,
                                                      'signup_form':
                                                      SignupForm})
            else:
                # print("raise error")
                messages.error(request, "User not found in the system")
                return render(request, 'login.html', {'login_form':
                                                      form,
                                                      'signup_form':
                                                      SignupForm})
        elif request.POST.get('submit') == 'sign_up':
            # print("sign up posted")
            form = SignupForm(request.POST)
            if form.is_valid():
                msgValidation = form.validateValues()
                if msgValidation is not None and len(msgValidation) > 0:
                    messages.error(request, msgValidation)
                    return render(request, 'login.html', {'login_form':
                                                          LoginForm,
                                                          'signup_form':
                                                          form})
                else:
                    user = form.save(commit=False)
                    user.active = True
                    user.staff = False
                    user.admin = False
                    user.set_password(request.POST.get('password'))
                    user.save()

                    message = 'Hi {}, we have received your details and \
                        will process soon.'.format(
                        request.POST.get('username',))
                    # recipient_list = [request.POST.get('email',), ]
                    recipient_list = [request.POST.get(
                        'email', 'vishaljaiswal.info@gmail.com'), ]
                    EmailThread("Thank you to registration",
                                message, recipient_list).start()
                    auth_login(
                        request, user, backend='django.contrib.auth.backends.ModelBackend')
                    return redirect('/dashboard')

            else:
                print("Invalid signup form")
                
                messages.error(request, form.errors["__all__"])
                form.errors['__all__'] = None
                return render(request, 'login.html', {'login_form':
                                                      LoginForm,
                                                      'signup_form':
                                                      form})
        return JsonResponse(request.POST)

home/templates/base.html
<!doctype html> {%load staticfiles%}
<html lang="en">

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"> -->
    <script src="https://code.jquery.com/jquery-3.4.1.js"></script>
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">
    <script src="https://code.jquery.com/jquery-3.4.1.js"></script>
    <title>Ercess Technologies</title>
</head>

<body>
    <!--Navbar -->
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="navbar-brand" href="#">Ercess</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
            aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav ml-auto">
                {% if user.is_authenticated %}
                <!-- <li class="nav-item">
                    <a class="nav-link" href="{#% url 'home:dashboard' #%}">Dashboard</a>
                </li> -->
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'home:logout' %}">Logout</a>
                </li>
                {% else %}
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'home:login' %}">Login</a>
                </li>
                {% endif %}
            </ul>

        </div>
    </nav>
    <!--/.Navbar -->


    {% if messages %} {% for message in messages %} {% if 'success' in message.tags %}
    <div class="alert alert-success text-center">
        <strong>{{ message|escape }}</strong>
    </div>

    {% elif message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
    <div class="alert alert-danger text-center">
        <strong>{{ message|escape|striptags }}</strong>
    </div>
    {% endif %} {% endfor %} {% endif %}
    {% block content%} {% endblock %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script> -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
        integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
        crossorigin="anonymous"></script>
</body>

</html>

home/templates/dashboard.html
{% extends "base.html"%}
{% block content%}
<!-- <nav aria-label="breadcrumb" class="position-fixed">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{% url 'home:index' %}">Home</a></li>
        <li class="breadcrumb-item active">Dashboard</li>
    </ol>
</nav> -->
<br>
<div class="mt-3 ml-3">
    <h1>{{request.user.username}}!!!, welcome to your dashboard</h1>
</div>
{% endblock%}

home/templates/index.html
{% extends "base.html"%}
{% block content%}
<div class="container">
    <h1>Welcome, This is the Landing Page of Ercess</h1>
</div>
{% endblock%}

home/templates/login.html
{% extends "base.html" %}
{% load crispy_forms_tags %}
{% block content %}
<div class="container">
    <div class="row">
        <div class="col-6">
            <form method="post">
                {% csrf_token %}
                <fieldset class="form-group">
                    <legend class="border-bottom mb-4">Login</legend>
                    {{ login_form|crispy }}
                </fieldset>
                <div class="form-group">
                    <button type="submit" class="btn btn-outline-info" name="submit" value='sign_in'>Login</button>
                </div>
            </form>
        </div>
        <div class="col-6">
            <form method="post">
                {% csrf_token %}
                <fieldset class="form-group">
                    <legend class="border-bottom mb-4">SignUp</legend>
                    {{ signup_form|crispy }}
                   
                </fieldset>
                <div class="form-group">
                    <button type="submit" class="btn btn-outline-info" name="submit" value='sign_up'>Signup</button>
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock %}